/*
 *  CoreAudioMixerProvider.cpp
 *  CoreAudioJavaSoundLib
 *
 *  Created by Klaus Jänsch on 31.01.12.
 *  Copyright 2012 __MyCompanyName__. All rights reserved.
 *
 */

#include <CoreFoundation/CFString.h>
#include <CoreFoundation/CoreFoundation.h>
#include <CoreAudio/CoreAudioTypes.h>
#include <CoreAudio/AudioHardware.h>
//#include <HostTime.h>
#include <CoreAudio/CoreAudio.h>
//#include "/System/Library/Frameworks/CoreAudio.framework/Versions/A/Headers/CFString.h"
#include "CoreAudioMixerProvider.h"
#include <JavaVM/jni.h>


//namespace std {

JNIEXPORT void JNICALL Java_ips_audio_coreaudio_CoreAudioMixerProvider_enumerateCards(JNIEnv *env, jobject obj) {
	jclass cls=env->FindClass("ips/audio/coreaudio/CoreAudioMixerProvider");
	if(cls==NULL){
		fprintf(stderr,"Java Class not found!");
		return;
	}
	jmethodID mId=env->GetMethodID(cls,"nextDevice","(Ljava/nio/ByteBuffer;)V");
	if(mId==NULL){
		fprintf(stderr,"Method not found!");
		return;
	}
	
	UInt32 dataSize;
	AudioObjectPropertyAddress propertyAddress;
	propertyAddress.mSelector = kAudioHardwarePropertyDevices;
	propertyAddress.mScope    = kAudioObjectPropertyScopeWildcard;
	propertyAddress.mElement  = kAudioObjectPropertyElementMaster;
	OSStatus result =
	AudioObjectGetPropertyDataSize(kAudioObjectSystemObject, &propertyAddress, 0, NULL, &dataSize);
	if(result==0){
		AudioDeviceID* audioDevices=(AudioDeviceID*)malloc(dataSize);
		AudioObjectGetPropertyData(kAudioObjectSystemObject, &propertyAddress, 0, NULL, &dataSize,audioDevices);
		for(unsigned int i=0;i<dataSize/sizeof(AudioDeviceID);i++){
			UInt32 devOs;
			
			//AudioObjectShow(audioDevices[i]);
			jobject aId=env->NewDirectByteBuffer(&audioDevices[i],sizeof(AudioDeviceID));
			
			propertyAddress.mSelector=kAudioDevicePropertyDeviceNameCFString;
			AudioObjectGetPropertyDataSize(audioDevices[i],&propertyAddress,0,NULL,&devOs);
			CFStringRef name=(CFStringRef)malloc(devOs);
			AudioObjectGetPropertyData(audioDevices[i],&propertyAddress,0,NULL,&devOs,&name);
			
			
			
			//const char * nameC=CFStringGetCStringPtr(name,NULL);
			//printf("Name %s\n",nameC);
			//jstring nameJ=env->NewStringUTF(nameC);
			env->CallVoidMethod(obj,mId,aId);
			
					
			
			//CFStringRef mName=malloc(100);
			//AudioDeviceGetProperty(audioDevices[i],0,FALSE,kAudioDevicePropertyModelUID,&devOs,&mName);
			//char * mNameC=CFStringGetCStringPtr(mName,0);
			//printf("Name model %s\n",mNameC);
			
			
		}
		
	}
	
	
}

CoreAudioMixerProvider::CoreAudioMixerProvider() {
	// TODO Auto-generated constructor stub
	
}

CoreAudioMixerProvider::~CoreAudioMixerProvider() {
	// TODO Auto-generated destructor stub
}


void CoreAudioMixerProvider::printDevices() {
	//cout << "!!!Hello World!!!" << endl; // prints !!!Hello World!!!
	printf("Devices:\n");
	printf("bla");
	//UInt32 outSize;
	//Boolean outWritable;
	UInt32 dataSize;
	AudioObjectPropertyAddress propertyAddress;
	propertyAddress.mSelector = kAudioHardwarePropertyDevices;
	propertyAddress.mScope    = kAudioObjectPropertyScopeWildcard;
	propertyAddress.mElement  = kAudioObjectPropertyElementMaster;
	OSStatus result =
	AudioObjectGetPropertyDataSize(kAudioObjectSystemObject, &propertyAddress, 0, NULL, &dataSize);
	if(result==0){
		AudioDeviceID* audioDevices=(AudioDeviceID*)malloc(dataSize);
		AudioObjectGetPropertyData(kAudioObjectSystemObject, &propertyAddress, 0, NULL, &dataSize,audioDevices);
		for(unsigned int i=0;i<dataSize/sizeof(AudioDeviceID);i++){
			//AudioDeviceID *adid=buf[i];
			//			printf("dev: %d\n",adid);
			UInt32 devOs;
			
			//AudioDeviceGetPropertyInfo(audioDevices[i],0,TRUE,kAudioDevicePropertyDeviceNameCFString,&devOs,&outWritable);
			AudioObjectShow(audioDevices[i]);
			
			
			propertyAddress.mSelector=kAudioDevicePropertyDeviceNameCFString;
			AudioObjectGetPropertyDataSize(audioDevices[i],&propertyAddress,0,NULL,&devOs);
			CFStringRef name=(CFStringRef)malloc(devOs);
			AudioObjectGetPropertyData(audioDevices[i],&propertyAddress,0,NULL,&devOs,&name);
			
			
			
			const char * nameC=CFStringGetCStringPtr(name,NULL);
			printf("Name %s\n",nameC);
			
			//CFStringRef mName=malloc(100);
			//AudioDeviceGetProperty(audioDevices[i],0,FALSE,kAudioDevicePropertyModelUID,&devOs,&mName);
			//char * mNameC=CFStringGetCStringPtr(mName,0);
			//printf("Name model %s\n",mNameC);
			
			
		}
		
	}
	
	
	return ;
}

//} /* namespace std */

